$INTERFACE UDLLI1                                             97/12/01
$REM LU
  $CON1='1.0$P-2'
  $CON2='1.0$P-60'
  $CON3='2.0$P 0'
  $ICON1=0
  $ICON2=4
  $ICON3=32
  $ICON4=5
  $BG='BG'
  $IBG='IBG'
  $JBG='JBG'
  $HELP
    NUMBER OF BFGS CORRECTIONS
  $CHECK(MF,6,INT,2)
  $HELP
    PRELIMINARY PERMUTATION OF THE JACOBIAN MATRIX
      0 - NO PERMUTATION
      1 - PERMUTATION TO BLOCK TRIANGULAR FORM
  $CHECK(MOS2,0,'0\1',3)
  $HELP
    PREFERRENCE OF SYMMETRIC PIVOTS
      0 - SYMMETRIC PIVOTS ARE NOT PREFERRED
      1 - SYMMETRIC PIVOTS ARE PREFERRED
  $CHECK(MOS3,0,'0\1',3)
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'1.0$P-10',REAL,4)
  $IF(UPDATE='NO')
    MF=0
  $ENDIF
  $ADD(REAL,'\$BG($MMAX)\$AG($MA)\$XM($NF*$MF)\$GM($MF)&
  \$AF($NA)\$SN(2*$NF)\$XO($NF)')
  $ADD(INTEGER,'\$IBG($MMAX+1)\$JB(15)\$IB(5)\$IAG($NA+1)\$JAG($MA)&
  \$JBG($MA)\$IH($MF)')
  $ADD(INTEGER,'\I\MM')
  $ADD(REAL,'\UXVDOT')
  $N='NF'
  CALL UOD1D1
  CALL UXSGMC($N,MA,$AG,$IAG,$JAG,ETA2)
  MM=NIT-KIT
  IF (MM.EQ.0) THEN
  IF (NIT-LIT.LE.1) THEN
  DO $30 I=1,NA
  DO $20 KA=$IAG(I),$IAG(I+1)-1
  JBG(KA)=I
$20 CONTINUE
$30 CONTINUE
  CALL UXIINI($JB,INF,1,MMAX+1,1,MMAX+1)
  CALL UXSGDS($BG,$IBG,$JB,$AG,$JAG,$JBG,$N,MA,$IB,INF,$CON1,$CON2&
  ,$CON3,$ICON1,$ICON2,$ICON3,$ICON4,$MOS2,$MOS3)
  ELSE
  CALL UXSGDF($BG,$IBG,$JB,$AG,$JAG,$JBG,$N,MA,$IB,INF,$CON2,$ICON3)
  ENDIF
  NDECA=NDECA+1
  IDECA=2
  IF (INF.NE.0) THEN
  ITERD=-7
  TDXX='DEC ERR.'
  GO TO $50
  ENDIF
  ENDIF
  CALL UXLIDM($N,MM,MMAX,$BG,$IBG,$JB,$IB,$XM,$GM,$IH,$AF,$XO,$SN)
  CALL UXVNEG($N,$XO,$SN)
  INITD=MAX(ABS(INITD),1)
  ITERD = 1
  TDXX='INV FORM'
  SNORM=SQRT(UXVDOT($N,$SN,$SN))
  GNORM=SNORM
  P=-F
$50 CONTINUE
  CALL UOD1D2($N,$AF,$SN)
  $ADD(INIT)
    NDXX='UDLLI1'
  $ENDADD
  $EXIT
