$INTERFACE UP1FF9                                             99/12/01
  $SUBST('UZCSET')
  $HELP
    TYPE OF EXTREMUM:
       0 - MINIMUM
       1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    PENALTY FUNCTION FOR COMPLEMENTARITY CONSTRAINTS
       1 - THE L1 EXACT PENALTY FUNCTION
       2 - THE SUM OF SQUARES
  $CHECK(MEC,1,'1\2',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $HELP
    INITIAL VALUE OF SLACK VARIABLES
  $CHECK(EPS7,'1.0$P-1',REAL,4)
  $HELP
    INITIAL VALUE OF LAGRANGE MULTIPLIERS
  $CHECK(EPS8,'1.0$P-1',REAL,4)
  $ADD(REAL,'\$X($NF)\$XL($NX)\$XU($NX)\$XSL($NX)\$XSU($NX)\$XZL($NX)&
  \$XZU($NX)\$GF($NF)\$CL($NC)\$CU($NC)\$CSL($NC)\$CSU($NC)\$CZL($NC)&
  \$CZU($NC)\$GC($NF)\$G($NF)')
$REM  $ADD(REAL,'\EPS7\EPS8\RPF4\FF\FC\F\CMAX')
  $ADD(INTEGER,'\$IX($NX)\$IXE($NX)\$IC($NC)\$ICE($NC)\ICC(2*$NCC)&
  \$ICG($NC+1)\$JCG($MC)')
$REM  $ADD(INTEGER,'\NF\NX\NC\NCC\MC\KC')
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ---------------------------
*     PENALTY FUNCTION DEFINITION
*     ---------------------------
*
$OPTION(CHDIR=CHPOM)
 $00  CALL UP1FF9(NF,NX,NC,NCC,MC,KC,$X,$IX,$IXE,$XL,$XU,$XSL,$XSU&
,$XZL,$XZU,$GF,$IC,$ICE,$ICC,$CL,$CU,$CSL,$CSU,$CZL,$CZU,$GC,$ICG,$JCG&
,$G,EPS7,EPS8,RPF4,FF,FC,F,CMAX,$MEC)
      GO TO ($90,$10,$20,$50,$60) ISB+1
 $10  CONTINUE
      $MTYPE=FMODF
      $SUBST('UZFMOD')
      GO TO $00
 $20  CONTINUE
      $IF(GMODF='G')
        $MTYPE='G'
        $SUBST('UZFMOD')
        GO TO $00
      $ELSEIF(FMODF='F')
        $HELP
          METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
          NUMERICAL COMPUTATION OF GRADIENT:
            0 - CONSTANT DIFFERENCE
            1 - EASY COMPARATIVE METHOD
            2 - STEWART'S METHOD.
        $CHECK(MCG,2,'0\1\2',3)
        $IF(MCG=0)
          $SUBST('UF0G$(CON)1')
        $ELSE
          $SUBST('UF0G$(CON)2')
        $ENDIF
        GO TO ($40,$30) ISB+1
 $30  CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $20
 $40  CONTINUE
        GO TO $00
      $ELSEIF(.TRUE.)
        IF (LD.LT.0) GO TO $00
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $00
      $ELSE
        GO TO $00
      $ENDIF
 $50  CONTINUE
      $IF(SAVC>-1)
        IF(LDC.GE.0) THEN
        FC=$CF(KC)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL<>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNF3')
        $IF(KBC>0) $SUBST('UCTRF1')
        $IF(ISNC>0)
          $SUBST('UCSVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<0)
        $IF(NCL<>NC)
          $MTYPE=FMODC
          $SUBST('UZCMOD')
          $IF(NORMC>0) $SUBST('UCNRF1')
          $IF(KBC>0) $SUBST('UCTRF1')
          $IF(ISNC>0)
            $SUBST('UCSVF1')
          $ENDIF
          $IF(FMODC<>'F')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $60  CONTINUE
      $IF(SAVC>0)
        IF(LDC.GE.1) THEN
        $SUBST('UCLNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL<>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<1)
        $IF(NCL<>NC)
          $IF(GMODC='G')
            $MTYPE='G'
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(FMODC='F')
            $IF(ISNC>0)
              IF (LD.GE.0) FC=$CF(KC)
            $ENDIF
 $65  CONTINUE
            $SUBST('UC0G$(CON)3')
            GO TO ($80,$70) ISB+1
 $70  CONTINUE
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            GO TO $65
 $80  CONTINUE
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(.TRUE.)
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSE
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $90  CONTINUE
      LD=KD
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ----------------------------------
*     END OF PENALTY FUNCTION DEFINITION
*     ----------------------------------
*
$OPTION(CHDIR=CHPOM)
      $ADD(INIT)
        NPXX='UP1FF9'
      $ENDADD
      $EXIT
