$INTERFACE UP2FF4                                             98/12/01
  $LHELP=.FALSE.
  $IF(KDF=2) $LHELP=.TRUE.
  $IF(KDC=2) $LHELP=.TRUE.
  $IF(NUMDER=1) $LHELP=.TRUE.
  $IF(LHELP)
  $SUBST('UZCSET')
  $HELP
    TYPE OF EXTREMUM:
       0 - MINIMUM
       1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
  $HELP
    MAXIMUM NUMBER OF NONZERO ELEMENTS IN THE
    CONSTRAINT FUNCTION HESSIAN MATRIX
  $CHECK(MHC,100,INT,1)
  $ADD(SINID)
    $SUBST('UCSET8')
  $ENDADD
  $ADD(REAL,'\$GF($NF)\$HF($M)\$GC($NF)\$HC($MHC)\$G($NF)\$H($M)&
  \$CZ($NC)')
$REM  $ADD(REAL,'\FF\FC\F\CMAX')
  $ADD(INTEGER,'\$ICG($NC+1)\$JCG($MC)\$IH($NF+1)\$JH($M)')
$REM  $ADD(INTEGER,'\NF\NC\NCL\MC\MHC\KC\M')
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ---------------------------
*     PENALTY FUNCTION DEFINITION
*     ---------------------------
*
$OPTION(CHDIR=CHPOM)
 $00  CALL UP2FF4(NF,NC,NCL,MC,MHC,KC,M,$GF,$HF,$GC,$HC,$ICG,$JCG,$G,$H&
,$IH,$JH,$CZ,FF,FC,F,CMAX)
      GO TO ($90,$10,$20,$50,$15,$25,$55) ISB+1
 $10  CONTINUE
      $MTYPE=FMODF
      $SUBST('UZFMOD')
      $IF(FMODF<>'F')
      $ENDIF
      GO TO $00
 $20  CONTINUE
      $IF(GMODF='G')
        $MTYPE='G'
        $SUBST('UZFMOD')
        GO TO $00
      $ELSEIF(FMODF='F')
        $HELP
          METHOD FOR DETERMINATION OF DIFFERENCE USED FOR
          NUMERICAL COMPUTATION OF GRADIENT:
            0 - CONSTANT DIFFERENCE
            1 - EASY COMPARATIVE METHOD
            2 - STEWART'S METHOD.
        $CHECK(MCG,2,'0\1\2',3)
        $IF(MCG=0)
          $SUBST('UF0G$(CON)1')
        $ELSE
          $SUBST('UF0G$(CON)2')
        $ENDIF
        GO TO ($40,$30) ISB+1
 $30  CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $20
 $40  CONTINUE
        GO TO $00
      $ELSEIF(.FALSE.)
        IF (LD.LT.0) GO TO $00
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $00
      $ELSE
        GO TO $00
      $ENDIF
 $50  CONTINUE
      $IF(HMODF='H')
        $MTYPE='H'
        $SUBST('UZFMOD')
        GO TO $00
      $ELSEIF(GMODF='G')
        $SUBST('UF1H$(CON)2')
        GO TO ($00,$60) ISB+1
  $60 CONTINUE
        $MTYPE=GMODF
        $SUBST('UZFMOD')
        GO TO $50
      $ELSEIF(FMODF='F')
        $SUBST('UF0H$(CON)2')
        GO TO ($00,$70) ISB+1
  $70 CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $50
      $ELSEIF(FMODF='FG')
        $SUBST('UF1H$(CON)2')
        GO TO ($00,$80) ISB+1
  $80 CONTINUE
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $50
      $ELSEIF(.FALSE.)
        IF (LD.LT.0) GO TO $00
        $MTYPE=FMODF
        $SUBST('UZFMOD')
        GO TO $00
      $ELSE
        GO TO $00
      $ENDIF
 $15  CONTINUE
      $IF(SAVC>-1)
        IF(LDC.GE.0) THEN
        FC=$CF(KC)
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL<>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNF3')
        $IF(KBC>0) $SUBST('UCTRF1')
        $IF(ISNC>0)
          $SUBST('UCSVF1')
        $ENDIF
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<0)
        $IF(NCL<>NC)
          $MTYPE=FMODC
          $SUBST('UZCMOD')
          $IF(NORMC>0) $SUBST('UCNRF1')
          $IF(KBC>0) $SUBST('UCTRF1')
          $IF(ISNC>0)
            $SUBST('UCSVF1')
          $ENDIF
          $IF(FMODC<>'F')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
          $ENDIF
          $IF(FMODC='FGH')
            $IF(NORMC>0) $SUBST('UCNRH3')
          $ENDIF
          GO TO $00
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $25  CONTINUE
      $IF(SAVC>0)
        IF(LDC.GE.1) THEN
        $SUBST('UCLNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(NCL<>0)
        IF(KC.LE.NCL) THEN
        $SUBST('UCLNG3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<1)
        $IF(NCL<>NC)
          $IF(GMODC='G')
            $MTYPE='G'
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(FMODC='F')
            $IF(ISNC>0)
              IF (LD.GE.0) FC=$CF(KC)
            $ENDIF
 $26  CONTINUE
            $SUBST('UC0G$(CON)3')
            GO TO ($45,$35) ISB+1
 $35  CONTINUE
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            GO TO $26
 $45  CONTINUE
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSEIF(.FALSE.)
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(ISNC>1)
              $SUBST('UCSVG3')
            $ENDIF
            GO TO $00
          $ELSE
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $55  CONTINUE
      $IF(NCL<>0)
        IF(KC.LE.NCL) THEN
$REM        $SUBST('UCLNH3')
        GO TO $00
        ENDIF
      $ENDIF
      $IF(LCD<2)
        $IF(NCL<>NC)
          $IF(HMODC='H')
            $MTYPE='H'
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRH3')
            GO TO $00
          $ELSEIF(GMODC='G')
            $SUBST('UC1H$(CON)3')
            GO TO ($00,$65) ISB+1
 $65 CONTINUE
            $MTYPE=GMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            GO TO $55
          $ELSEIF(FMODC='F')
            $IF(ISNC>0)
              IF (LD.GE.0) FC=$CF(KC)
            $ENDIF
 $66  CONTINUE
            $SUBST('UC0H$(CON)3')
            GO TO ($00,$75) ISB+1
 $75  CONTINUE
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            GO TO $66
          $ELSEIF(FMODC='FG')
            $SUBST('UC1H$(CON)3')
            GO TO ($00,$85) ISB+1
 $85  CONTINUE
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRG1')
            GO TO $55
          $ELSEIF(.FALSE.)
            IF (LD.LT.0) GO TO $00
            $MTYPE=FMODC
            $SUBST('UZCMOD')
            $IF(NORMC>0) $SUBST('UCNRF1')
            $IF(KBC>0) $SUBST('UCTRF1')
            $IF(NORMC>0) $SUBST('UCNRG1')
            $IF(NORMC>0) $SUBST('UCNRH3')
            GO TO $00
          $ELSE
            GO TO $00
          $ENDIF
        $ENDIF
      $ELSE
        $GO TO $00
      $ENDIF
 $90  CONTINUE
      LD=KD
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     ----------------------------------
*     END OF PENALTY FUNCTION DEFINITION
*     ----------------------------------
*
$OPTION(CHDIR=CHPOM)
$ADD(INIT)
  NPXX='UP2FF4'
$ENDADD
$ELSE
  $HELP
    TYPE OF EXTREMUM:
       0 - MINIMUM
       1 - MAXIMUM
  $CHECK(IEXT,0,'0\1',1)
  $HELP
    LOWER BOUND FOR FUNCTION VALUE
  $CHECK(FMIN,'-$ETA9',REAL,2)
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     -------------------------
*     NUMERICAL DIFFERENTIATION
*     -------------------------
*
$OPTION(CHDIR=CHPOM)
      ISNCS=ISNC
 $00  CALL UP2PF3
      GO TO ($30,$10,$20) ISB+1
 $10  CONTINUE
      IF (TSS(NS).NE.'UPXX') THEN
      LD=MIN(LD,0)
      LDC=MIN(LDC,0)
      $IF(NCL<>NC)
        $IF(GMODC<>'G')
          $IF(FMODC='F')
            LD=-1
            LDC=-1
          $ENDIF
        $ENDIF
      $ENDIF
      ENDIF
      $SUBST('UP1FF4')
      IF (TSS(NS).EQ.'UPXX') GO TO $00
 $20  CONTINUE
      $GFS=GF
      $XSS=XS
      $XS=GS
      $GF=G
      $KHLP=1
      $IF(KDF<1)
        $IF(KDC<1) $KHLP=0
      $ENDIF
      ISNC=0
      $SUBST('UF$(KHLP)H$(CON)2')
      GO TO ($00,$10) ISB+1
 $30  CONTINUE
      ISNC=ISNCS
      $GF=GFS
      $XS=XSS
$CHPOM='$$'
$IF(.FALSE.)
*IF(.TRUE.)
*CHPOM='*'
*OPTION(CHDIR='$')
$ENDIF
*
*     --------------------------------
*     END OF NUMERICAL DIFFERENTIATION
*     --------------------------------
*
$OPTION(CHDIR=CHPOM)
$ADD(INIT)
  NPXX='UP1AF3'
  NFHX='UF$(KHLP)H$(CON)2'
$ENDADD
$ENDIF
$EXIT
