$INTERFACE U1MSI1                                             16/12/01
$REM LU
  $OPTION(LPERFD=.TRUE.)
  $GF='GF'
  $ADD(INTEGER,'\NFO\NAO\NCO\MCO\IMS\J\K\L')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
  $HELP
    REPRESENTATION OF THE ADDITIONAL VARIABLE
      0 - LINEAR
      1 - NONLINEAR
  $CHECK(MEP5,0,'0\1',2)
  $IF(NC=0)
    $MC=0
    $MCH=0
    $KDC=KDA
    $KBC=1
    $CU=CL
    $FMODC='X'
    $GMODC='X'
    $IF($DEF(FMODELA))
      $SET(FMODELC)
*       NEW FMODELC
      $ENDSET
      $FMODC='F'
    $ENDIF
    $IF($DEF(GMODELA))
      $SET(GMODELC)
*       NEW GMODELC
      $ENDSET
      $GMODC='G'
    $ENDIF
    $IF($DEF(FGMODELA))
      $SET(FGMODELC)
*       NEW FGMODELC
      $ENDSET
      $FMODC='FG'
    $ENDIF
    $CRED='NO'
    $MODELC='YES'
    $LDC=-1
$REM    $SUBST('UZMODC')
  $ENDIF
  KBC=$KBC
  $NFO=NF
  $NXO=NX
  $NAO=NA
  $NCO=NC
  $MCO=MC
  $NAOLD='NAO'
  $ADD(SINIT)
    CALL UXVINP(NF+2,$IH)
    CALL UXVINP(NF+1,$JH)
  $ENDADD
  $ADD(SINID)
*
*     -----------------------------
*     TRANSORMATION OF MINIMAX TO A
*     NONLINEAR PROGRAMMING PROBLEM
*     TEMPLATE : U1MSI1
*     -----------------------------
*
    IF (NC.EQ.0) MC=0
    NFO=NF
    NAO=NA
    NCO=NC
    MCO=MC
    NF=NF+1
    $X(NF)=0.0$P 0
    CALL UXVINS(NA,2,$IC(NC+1))
    CALL UXVSET(NA,ZERO,$CU(NC+1))
    CALL UXVICP(MA,$JAG,$JCG(MC+1))
    DO $10 KA=1,NA+1
    $ICG(NC+KA)=MC+$IAG(KA)
$10 CONTINUE
    DO $30 KC=NA,1,-1
    K=$ICG(KC+NC)
    L=$ICG(KC+NC+1)-1
    DO $20 J=L,K,-1
    $JCG(J+KC-1)=$JCG(J)
$20 CONTINUE
    $JCG(L+KC)=NF
    $ICG(KC+NC+1)=$ICG(KC+NC+1)+KC
$30 CONTINUE
    NC=NC+NA
    MC=$ICG(NC+1)-1
    $IF('$IEXT'=0)
      CALL UXVINS(NA,1,$IC(NC+1))
      CALL UXVSET(NA,ZERO,$CL(NC+1))
      CALL UXVICP(MC-MCO,$JCG($ICG(NCO+1)),$JCG($ICG(NC+1)))
      DO $40 KA=NA+1,1,-1
      $ICG(NC+KA)=MC-MCO+$ICG(NCO+KA)
$40   CONTINUE
      NC=NC+NA
      MC=$ICG(NC+1)-1
    $ENDIF
    NA=1
    MA=1
    MAH=10
    IBG(1)=1
    IBG(2)=2
    JBG(1)=NF
    $IF(MEP5=0)
      NAL=1
      $AG(1)=ONE
    $ELSE
      NAL=0
    $ENDIF
    $SUBST('UFSET5')
    IF ($IH(NF+1)-1.GT.$M) THEN
    CALL UOERR2('U1MSI1',75,$IH(NF+1)-1,$M)
    CALL UOERR4
    ITERM=-75
    ENDIF
  $ENDADD
  $SUBST('UCMAX1')
  $NF='$NF+1'
  $NX=NF
  $IF(IEXT=0)
    $NCP=NC
    $NC='$NC+2*$NA'
    $MC='$MC+2*$MA'
    $IF($DEF(MCH))
      $IF($DEF(MAH))
        $MCH='$MCH+2*$MAH'
      $ENDIF
    $ENDIF
  $ELSE
    $NCP=NC
    $NC='$NC+$NA'
    $MC='$MC+$MA'
    $IF($DEF(MCH))
      $IF($DEF(MAH))
        $MCH='$MCH+$MAH'
      $ENDIF
    $ENDIF
  $ENDIF
  $NA=1
  $MA=1
  $MAH=10
  $IAGS=IAG
  $JAGS=JAG
  $IAG='IBG'
  $JAG='JBG'
  $JACA='S'
  $IF(MEP5=0)
    $NAL=1
  $ELSE
    $NAL=0
    $SET(FMODELA)
    FA=X(NF)
    $ENDSET
    $SET(GMODELA)
    GA(NF)=ONE
    $ENDSET
    $KDA=1
  $ENDIF
  $MCOLS=NF
  $OPTION(LPERFD=.FALSE.)
  $SUBST('U1F$(FORM)1')
  $NF=NFO
  $NX=NXO
  $NA=NAO
  $NC=NCO
  $MC=MCO
  NF=NF-1
  NA=NAO
  NC=NCO
  MC=MCO
  $IAG=IAGS
  $JAG=JAGS
  $ADD(INIT)
    NXFU='U1MSI1'
  $ENDADD
  $EXIT
