$INTERFACE U1MSI2                                             16/12/01
$REM LU
  $OPTION(LPERFD=.TRUE.)
  $GF='GF'
  $ADD(INTEGER,'\NFO\NCO\MCO\IMS\J\K\L')
  $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)')
  $ADD(REAL,'\$GA($NF)')
  $IF(NC=0)
    $MC=0
    $KDC=KDA
    $KBC=1
    $CU=CL
    $FMODC='X'
    $GMODC='X'
    $IF($DEF(FMODELA))
      $SET(FMODELC)
*       NEW FMODELC
      $ENDSET
      $FMODC='F'
    $ENDIF
    $IF($DEF(GMODELA))
      $SET(GMODELC)
*       NEW GMODELC
      $ENDSET
      $GMODC='G'
    $ENDIF
    $IF($DEF(FGMODELA))
      $SET(FGMODELC)
*       NEW FGMODELC
      $ENDSET
      $FMODC='FG'
    $ENDIF
    $CRED='NO'
    $MODELC='YES'
    $LDC=-1
$REM    $SUBST('UZMODC')
  $ENDIF
  KBC=$KBC
  $NFO=NF
  $NXO=NX
  $NCO=NC
  $MCO=MC
  $NAOLD='NA'
  $ADD(SINID)
*
*     -----------------------------
*     TRANSORMATION OF MINIMAX TO A
*     NONLINEAR PROGRAMMING PROBLEM
*     TEMPLATE : U1MSI2
*     -----------------------------
*
    IF (NC.EQ.0) MC=0
    NFO=NF
    NCO=NC
    MCO=MC
    NF=NF+1
    $X(NF)=0.0$P 0
    CALL UXVINS(NA,2,$IC(NC+1))
    CALL UXVSET(NA,ZERO,$CU(NC+1))
    CALL UXVICP(MA,JAG,$JCG(MC+1))
    DO $10 KA=1,NA+1
    $ICG(NC+KA)=MC+$IAG(KA)
$10 CONTINUE
    DO $30 KC=NA,1,-1
    K=$ICG(KC+NC)
    L=$ICG(KC+NC+1)-1
    DO $20 J=L,K,-1
    $JCG(J+KC-1)=$JCG(J)
$20 CONTINUE
    $JCG(L+KC)=NF
    $ICG(KC+NC+1)=$ICG(KC+NC+1)+KC
$30 CONTINUE
    NC=NC+NA
    MC=$ICG(NC+1)-1
    $IF('$IEXT'=0)
      CALL UXVINS(NA,1,$IC(NC+1))
      CALL UXVSET(NA,ZERO,$CL(NC+1))
      CALL UXVICP(MC-MCO,$JCG($ICG(NCO+1)),$JCG($ICG(NC+1)))
      DO $40 KA=NA+1,1,-1
      $ICG(NC+KA)=MC-MCO+$ICG(NCO+KA)
$40   CONTINUE
      NC=NC+NA
      MC=$ICG(NC+1)-1
    $ENDIF
  $ENDADD
  $SET(FMODELF)
    FF=$X(NF)
  $ENDSET
  $SET(GMODELF)
    CALL UXVSET(NF-1,ZERO,$GF)
    $GF(NF)= ONE
  $ENDSET
  $KDF=1
  $SUBST('UCMAX1')
  $NF='($NF+1)'
  $NX=NF
  $IF(IEXT=0)
    $NCP=NC
    $NC='$NC+2*$NA'
    $MC='$MC+2*$MA'
  $ELSE
    $NCP=NC
    $NC='$NC+$NA'
    $MC='$MC+$MA'
  $ENDIF
  $MODELF='YES'
  $FMODF='F'
  $GMODF='G'
  $MCOLS=NF
  $OPTION(LPERFD=.FALSE.)
  $SUBST('U1F$(FORM)2')
  $NF=NFO
  $NX=NXO
  $NC=NCO
  $MC=MCO
  NF=NF-1
  NC=NCO
  MC=MCO
  $ADD(INIT)
    NXFU='U1MSI2'
  $ENDADD
  $EXIT
