$INTERFACE UYADP0                                             93/12/01
  $HELP
    SPECIFICATION OF THE CONSTRAINT ADDITION
      1 - ONLY ONE ACTIVE CONSTRAINT IS ADDED TO THE ACTIVE SET
      2 - ALL ACTIVE CONSTRAINTS ARE ADDED TO THE ACTIVE SET
  $CHECK(MLC1,2,'1\2',4)
  $HELP
    PRECISION FOR LINEAR INDEPENDENCE OF CONSTRAINTS.
  $CHECK(EPS7,'1.0$P-8',REAL,4)
  $HELP
    TOLERANCE FOR ACTIVE CONSTRAINTS
  $CHECK(EPS9,'1.0$P-8',REAL,4)
  CALL UYADP0(NF,N,MCL,MC,$MMAX,$X,$IX,$XN,$XL,$XU,$CF,$CFD,$IC,$ICA&
,$CL,$CU,$CG,$ICG,$JCG,$CR,$ICR,$JCR,$CZ,$S,R,$EPS7,$EPS9,GMAX,UMAX&
,$MLC1,INEW,IER)
  $ADD(REAL,'\$X($NF)\$XN($NF)\$XL($NF)\$XU($NF)\$CF($NC)\$CFD($NC)&
  \$CL($NC)\$CU($NC)\$CG($MC)\$CR($MMAX)\$CZ($NF)\$S($NF)')
  $ADD(INTEGER,'\$IX($NX)\$IC($NC)\$ICA($NF)&
  \$ICG($NC+1)\$JCG($MC)\$ICR($NF+1)\$JCR($MMAX)')
$REM  $ADD(INTEGER,'\$NF\N\MCL\MC\INEW\IER')
$REM  $ADD(REAL,'\R\GMAX\UMAX\')
  $EXIT
